#include <Wire.h>

// Global Variables
int i = 0;
int w = 0, x = 0;
int y = 10, z = 10;
byte DP = 0x7F;                         //   decimal point sets bit7 HIGH
byte D[4] = {0xD0, 0xD1, 0xD2, 0xD3};   //address of the MSB

byte number[17] = {0xC0, 0xF9, 0xA4, 0xB0, 0x99, 0x92, 0x82, 0xF8,
//                  0     1     2     3     4     5     6     7  
                   0x80, 0x90, 0x88, 0x83, 0xC6, 0xA1, 0x86, 0x8E, 0xFF};
//                  8     9     A     B     C     D     E     F     clr

void setup() {
  Wire.begin();
  clearDigits();
  for (i = 0; i < 4; i++) {               //set all digits to "8."
    writeI2C(i, 0x00);
    delay(500);
  }
  clearDigits();
}

void loop() {
  writeI2C(1, number[w] & DP);
  if (w == 9 && x == 9) {w = 0;} else if (w != 9 && x == 9) {w++;}
  writeI2C(0, number[x]);
  if (x == 9) {x = 0;} else {x++;}
  delay(500);

  writeI2C(3, number[y]);
  if (y == 15 && z == 15) {y = 10;} else if (y != 15 && z == 15) {y++;}
  writeI2C(2, number[z]);
  if (z == 15) {z = 10;} else {z++;}
  delay(500);
}

void clearDigits() {
  for (i = 0; i < 4; i++) {writeI2C(i, 0xFF);}
  delay(500);
}

void writeI2C(int digit, byte num) {
    Wire.beginTransmission(0x00);     //control byte
    Wire.write(D[digit]);             //address byte for digit
    Wire.write(num);                  //data byte for digit
    Wire.endTransmission();
}
